package com.waffle.com;
import java.util.ArrayList;
import java.util.List;

public class MyMath {
    public static double minMaxRange(double value, double minValue, double maxValue){
        return Math.max(minValue, Math.min(maxValue, value));
    }

    public static double normalize(double value, double minSource, double maxSource, double minTarget, double maxTarget){
        return (value-minSource) * (maxTarget-minTarget) / (maxSource-minSource) + minTarget;
    }

    public static double random(double minValue, double maxValue){
        return Math.random() * (maxValue-minValue) + minValue;
    }

    public static int random(int minValue, int maxValue){
        return (int)Math.floor(MyMath.random((double) minValue, (double) maxValue));
    }

    public List<Double> random(int nb, double minValue, double maxValue){
        List<Double> res = new ArrayList<>();
        for (int i = 0; i < nb; i++) {
            res.add(random(minValue, maxValue));
        }
        return res;
    }

    public List<Integer> random(int nb, int minValue, int maxValue){
        List<Integer> res = new ArrayList<>();
        for (int i = 0; i < nb; i++) {
            res.add(random(minValue, maxValue));
        }
        return res;
    }

    private static double min(List<List<Double>> altitudes){
        throw new UnsupportedOperationException();
    }
    private static double max(List<List<Double>> altitudes){
        throw new UnsupportedOperationException();
    }

    public List<List<Double>> altitudeToShadesOfGray(List<List<Double>> altitudes){
        List<List<Double>> matrix = new ArrayList<>();
        double altMin = min(altitudes);
        double altMax = max(altitudes);

        for (List<Double> line: altitudes){
            List<Double> res = new ArrayList<>();
            for (double alt: line){
                res.add(MyMath.normalize(alt, altMin, altMax, 0.0, 255.0));
            }
        }
        return matrix;
    }

}