package ch.hepia.exercice_4_4;
/*

Bière blanche 4.5 4.0
Bière ambrée 5.2 5.0
Soda Cola 0 3.5
Whisky 57.0 9.0
*/
public enum Beverage {
        whiteBeer("Bière blanche", 4.5, 4.0),
        amberBeer("Bière ambrée", 5.2, 5.0),
        sodaCola("Soda cola", 0.0, 5.0),
        whiskey("Whiskey", 57.0, 9.0);
      
        private final String name;
        private final Double percent;
        private final Double price;

        private Beverage(String name, Double percent, Double price) {
          this.name = name;
          this.percent = percent;
          this.price = price;
        }

        public String toString(){
            return this.name + " : CHF " + this.price;
        }

        static void check(Beverage drink){
            if (drink.percent > 0.0) {

                System.out.println("Contrôle d'âge nécéssaire.");

                if (drink.percent > 6.0){
                    System.out.println("La personne doit avoir 18 ans révolus.");
                }
                else{
                    System.out.println("La personne doit avoir 16 ans révolus");
                }
            }
            else{
                System.out.println("Bravo.");
            }

            System.out.println(drink);
        }
}
