# 4.8 Exercice

Soient les déclarations suivantes: 

```java
/* A
* / \
* B C
*/

class A {
	void test(double d) { System.out.println("A: double"); }
	void test(short s) { System.out.println("A: short"); }
}

class B extends A {
    // Surcharge
	void test(int i) { System.out.println("B: int"); }
    // Redefinition
	void test(short s) { System.out.println("B: short"); }
}

class C extends A {
    // Surcharge
	void test(float f) { System.out.println("C: float"); 
	void test(byte b) { System.out.println("C: byte"); }
}
```

Et soient les opérations suivantes:

```java
double d = 0.0;
float f = 0.0f;
int i = 0;
byte b = 0;
A ab = new B();
A ac = new C();
ab.test(b);
ac.test(b);
System.out.println("***");
ab.test(d);
ac.test(d);
System.out.println("***");
ab.test(f);
ac.test(f);
System.out.println("***");
ab.test(i);
ac.test(i);
```

1. Ecrivez le résultat qui serait affiché dans un terminal:

   ```java
   ab.test(b); // affiche "B : short"
   ac.test(b); // affiche "A : short"
   System.out.println("***");
   ab.test(d); // affiche "A : double"
   ac.test(d); // affiche "A : double"
   System.out.println("***");
   ab.test(f); // affiche "A: double"
   ac.test(f); // affiche "C: double"
   System.out.println("***");
   ab.test(i); // affiche "A: double"
   ac.test(i); // affiche "A: double"
   
   
   /* Comportement étrange...
   
   Quand on OVERRIDE, le code de A est literallement remplacé par celui de la sous classe. Dans le reste des cas, on utilise des fonctions de A car nos objets sont de type A.
   
   Sinon, il faudrait cast nos objets.
   
   */
   ```

   

2. Indiquez pourquoi l’instruction `B bc = new C();` pose problème en indiquant s’il s’agit d’une erreur de compilation ou d’exécution ?

   1. Parce que C n'es pas une sous classe de B

